#[cfg(target_family = "unix")]
use enigo::{KeyboardControllable};

#[cfg(target_family = "unix")]
pub fn type_text(text: &str) -> Result<(),()> {
    enigo::Enigo::default().key_sequence(text);
    Ok(())
}

#[cfg(target_family = "unix")]
pub fn click_tab() -> Result<(),()> {
    enigo::Enigo::default().key_click(enigo::Key::Tab);
    Ok(())
}

#[cfg(target_family = "windows")]
pub fn type_text(text: &str) -> Result<(),()>{
    simulate::type_str(text).map_err(|_| ())
}

#[cfg(target_family = "windows")]
pub fn click_tab() -> Result<(),()> {
    simulate::send(simulate::Key::Tab).map_err(|_| ())
}